/******************************************************************************\
**
**     COMPANY:	LDW
**
**      MODULE:	theChemicalTray
**
** DESCRIPTION:	Manages slots in the chemical tray
**
**      AUTHOR:	Adrian Francis
**
\******************************************************************************/

#ifndef THE_CHEMICAL_TRAY_H
#define THE_CHEMICAL_TRAY_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/
#include "theGameState.h"

/******************************************************************************\
** CONSTANT DEFINITIONS
\******************************************************************************/
const int theChemicalTray_c_iTopLeftX = 2;
const int theChemicalTray_c_iTopLeftY = 173;
const int theChemicalTray_c_iSlotWidth = 45;
const int theChemicalTray_c_iSlotHeight = 80;
 
/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class theChemicalTray
{
private:

	// class data
	static theChemicalTray *	m_Instance;

	theGameState *				m_pGameState;

	//class methods
	//setup
	public:		theChemicalTray(void);

	public:		static theChemicalTray *Get(void);
	public:		static void Destroy(void);

	//process
	public:		const bool AddChemical(const ItemChoiceEnum eChemicalID, const int iNumUses);
	public:		const bool SpaceInChemTray(const ItemChoiceEnum eChemicalID); //added wkh 6-26-07
	public:		void theChemicalTray::InitChemicals(); //added wkh 6-26-07
	public:		const bool RemoveChemical(const ItemChoiceEnum eChemicalID);
	public:		const bool UseChemical(const ItemChoiceEnum eChemicalID);
	public:		const int SelectChemical(const int iCursorX, const int iCursorY);
	public:		const int CheckMouseOverChemical(const int iCursorX, const int iCursorY);
	public:		void Draw(const int iExceptFor);

	//access
	public:		const ItemChoiceEnum GetChemical(const int iSlot);
	public:		const int GetNumUsesRemaining(const int iSlot);
};

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/