//
//		Definition of the main game class
//
#ifndef THE_COLLECTIONS_SCENE_H
#define THE_COLLECTIONS_SCENE_H


#include "ldwScene.h"
//#include "WorldMap.h"
#include "ldwGameWindow.h"
#include "ldwImage.h"
#include "theStringManager.h"

const int theCollectionsScene_iNumJars = 50;
const int theCollectionsScene_iJarWidth = 53;
const int theCollectionsScene_iJarHeight = 78;

static int theCollectionsScene_BugJarLeafInfo[theCollectionsScene_iNumJars][2] =
{

	2,6,
	54,6,
	107,6,
	2,100,
	54,100,
	106,100,//6
	110,217,
	6,321,
	63,321,
	123,321,//10
	96, 415,
	191,22,
	191,125,
	191,230,//14
	191,332,
	191,429,
	270,2,
	270,88,//18
	270,171,
	270,255,
	270,342,
	270,428,//22
	358,22,
	358,125,
	358,230,
	358,332,//26
	358,429,
	615,3,
	673,2,
	732,2,//30
	416,75,
	475,58,
	535,71,
	598,93,//34
	718,94,
	448,171,
	505,171,
	561,171,//38
	615,171,
	692,171,
	744,171,
	427,343,//42
	481,343,
	535,343,
	592,343,
	683,329,//46
	635,417,
	735,398

};

static int theCollectionsScene_BugJarInfo[theCollectionsScene_iNumJars][3] = {
	// x,y,bug
	0, 6, 0,
	53, 6, 1,
	106, 6, 2,
	0, 101, 3,
	53, 101, 4,
	106, 101, 5,
	109, 217, 6,
	5, 321, 7,
	62, 321, 8,
	122, 321, 9,
	95, 415, 10,// old style jar, needs moving
	190, 23, 11,
	190, 126, 12,
	190, 231, 13,
	190, 333, 14,
	190, 430, 15,
	269, 2, 16,
	269, 89, 17,
	269, 172, 18,
	269, 256, 19,
	269, 343, 20,
	269, 429, 21,
	357, 23, 22,
	357, 126, 23,
	357, 231, 24,
	357, 333, 25,
	357, 430, 26,
	614, 3, 27,
	672, 3, 28,
	731, 3, 29,
	415, 76, 30,
	474, 59, 31,
	534, 72, 32,
	597, 94, 33,
	717, 95, 34,
	447, 172, 35,
	504, 172, 36,
	559, 172, 37,
	614, 172, 38,
	691, 173, 39,
	743, 173, 40,
	426, 344, 41,
	480, 344, 42,
	534, 344, 43,
	591, 344, 44,
	682, 330, 45,
	634, 417, 46,
	734, 399, 47
};

class ldwButton;
class ldwSoundTrack;
class ldwSoundFx;
class theGameState;
class ldwTextControl;
class theSoundManager;
class theCollectingClass;
class theGraphicsManager;

class theCollectionsScene : public ldwScene
{
public:

	theCollectionsScene();
	~theCollectionsScene();

	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);
	bool ForwardWaitingMessage(StringId whichMessage);
	void theCollectionsScene::GetBugName(int bugNumber);


protected:
	void Activate(bool active);
	void DrawScene();
	void UpdateScene();

private:

	ldwGameWindow *gameWindow;
	theGameState  *gs;
	theSoundManager *soundMgr;
	theStringManager *stringMgr;
	theGraphicsManager *gm;

	int handAdjX;
	int handAdjY;
	int idx;

	bool fullScreenMode;
	bool pointerShowing;

	ldwUINT32 commFieldTimer;
	ldwRect displayRect;
	
	ldwRect butterfly1Rect;
	ldwRect butterfly2Rect;
	ldwRect butterfly3Rect;
	
	ldwRect shell1Rect;
	ldwRect shell2Rect;
	ldwRect shell3Rect;

	ldwRect pebble1Rect;
	ldwRect pebble2Rect;
	ldwRect pebble3Rect;
	
	ldwRect beetle1Rect;
	ldwRect beetle2Rect;
	ldwRect beetle3Rect;

	ldwImage *BG;
	//ldwImageGrid *butterflies;
	//ldwImageGrid *beetles;
	//ldwImageGrid *pebbles;
	//ldwImageGrid *shells;
	//ldwImageGrid *wheelPieces;

	ldwTextControl *playerCommField;

	char tempBugName[256];
	//ldwTextControl *sceneLabel;
#if 0
	ldwTextControl *butterfliesLabel;
	ldwTextControl *butterfliesProgressLabel;

	ldwTextControl *shellsLabel;
	ldwTextControl *shellsProgressLabel;

	ldwTextControl *beetlesLabel;
	ldwTextControl *beetlesProgressLabel;

	ldwTextControl *pebblesLabel;
	ldwTextControl *pebblesProgressLabel;

	ldwTextControl *gongLabel;
	ldwTextControl *gongProgressLabel;
#endif
	const int statsButtonId;
	//const int statsButtonId;
	//const int textInputId;

	ldwButton		*statsButton;

	bool customCursor;
	bool hideCursor;

	enum EBugState
	{
		eBugState_Idle,
		eBugState_Crawl,
		eBugState_Flutter,
		eBugState_TryToFly,
		eBugState_Hide,
	};

	struct SBugJar
	{
		ldwPoint	m_sPos;
		ldwPoint	m_sBugOffset;
		ldwPoint	m_sBugVelocity;
		int			m_iBugAnimFrame;
		int			m_iBugType;
		EBugState	m_eBugState;
		ldwUINT32	m_uiBugStateTimer;
		bool		m_bHasWeb;
		float		m_fAlpha;
	};

	SBugJar m_BugJarArray[theCollectionsScene_iNumJars];
};
#endif