//
//	Class definition for the Game State
//
//	- uses ldwGameState as base class
//

#ifndef THE_GAME_STATE_H
#define THE_GAME_STATE_H

#include "theStringManager.h"

#include "ldwGameState.h"
#include "ldwScene.h"
#include "ldwHintControl.h"

#define cLdwVersion							98

#define cDistributor						ldw

#define cDebug								false

#define cCheats								true

#define cLogging							true

#define cDemo								false

#define cSplashScreenEnabled				true
#define cSplashScreenDelay					4 //in seconds

#define cTraceOutput						true

#define canExpire							true

const ldwDate cExpirationDate = {9, 5,2007};

const bool cLaunchOnExitUrl =				true;


//#define ON_EXIT_URL "http://www.surveymonkey.com/s.aspx?sm=n4sJbUqZra2wZSZBrAlVuA_3d_3d"

#define ON_EXIT_URL "http://www.ldw.com/pt_win_buy/index.html"

typedef enum
	{
	ldw,
	real,
	wild,
	bfg
	
	} DistributorEnum;

#define difficultyLow			0
#define difficultyNorm			1
#define difficultyHi			2

typedef enum
{
	eNoTool = 0,
	eSoilTool = 1,
	eWaterTool,
	eScissorsTool,
	eNetTool,
	eChem1Tool,
	eChem2Tool,
	eChem3Tool,
	eChem4Tool,
	ePollinTool,
	eToolCount,
	eSeedTool = 20
	
} ToolsEnum;


// from PlantTycoon.h
#define toolAreaLimitX 200
#define toolAreaLimitY 200

#define maxNumWaitingPopups		10

#define randN(N)	ldwGameState::GetRandom(N)

#define messageDuration				4  //...in seconds

#define maxPlantSpecies				23

#define maxPotIndex                 5
#define potOffsetX                  28
#define potOffsetY                  15

//--- Plant Tycoon DEFINES

//- game speed defines

#define gameSpeedPaused				9999
#define gameSpeedSlow				15
#define gameSpeedNormal				10
#define gameSpeedFast				2

#define plantLiveAreaX				0  // for ppc - was 0
#define plantLiveAreaY				88 // for ppc was 32
#define plantLiveAreaWidth			144 // for ppc was 72
#define plantLiveAreaHeight			216 // for ppc was 108

//- preference settings for game difficulty

#define difficultySettingEasy		0
#define difficultySettingMedium		1
#define difficultySettingHard		2

//PPC screen defines
#define gardenBlitYOffset			40
#define gardenBlitWidth				240
#define gardenBlitHeight			220

// Collecting/Collectable defines
#define maxNumCollectableTypes	48
#define numberInCollection		12

//- text bar area defines (for text bar which contains all printed text messages)
#define textbarTopLeftX				0
#define textbarTopLeftY				256
#define textbarExtentX				240	
#define textbarExtentY				24

#define plantNameX					118
#define plantNameY					254

//- intro2 screen YES/NO BUTTONS defines
#define intro2YesX					24
#define intro2YesY					286
#define intro2YesWidth				84
#define intro2YesHeight				32

#define intro2NoX					137
#define intro2NoY					286
#define intro2NoWidth				84
#define intro2NoHeight				32


//- options menu defines
#define optionsContinueX			55
#define optionsContinueY			130
#define optionsContinueWidth		155
#define optionsContinueHeight		22
#define optionsContinueDecalX		29
#define optionsContinueDecalY		109

#define optionsNewX					55
#define optionsNewY					151
#define optionsNewWidth				155
#define optionsNewHeight			22

#define optionsStatisticsX			55
#define optionsStatisticsY			173
#define optionsStatisticsWidth		155
#define optionsStatisticsHeight		22

#define optionsPrefsX				55
#define optionsPrefsY				193
#define optionsPrefsWidth			155
#define optionsPrefsHeight			22

#define optionsExitX				55
#define optionsExitY				216
#define optionsExitWidth			155
#define optionsExitHeight			22

#define optionsRegisterX			55
#define optionsRegisterY			238
#define optionsRegisterWidth		155
#define optionsRegisterHeight		22
#define optionsRegisterDecalX		29
#define optionsRegisterDecalY		235

#define optionsAboutX				221
#define optionsAboutY				304
#define optionsAboutWidth			19
#define optionsAboutHeight			16


#define mainNavOptionsX				6
#define mainNavOptionsY				289
#define mainNavOptionsWidth			50
#define mainNavOptionsHeight		20

#define mainNavHelpX				179
#define mainNavHelpY				289
#define mainNavHelpWidth			50
#define mainNavHelpHeight			20

#define mainNavSeedX				7
#define mainNavSeedY				48
#define mainNavSeedWidth			35
#define mainNavSeedHeight			35

#define mainNavShopX				57
#define mainNavShopY				50
#define mainNavShopWidth			35
#define mainNavShopHeight			35

#define mainNavGardenX				102
#define mainNavGardenY				47
#define mainNavGardenWidth			35
#define mainNavGardenHeight			35

#define mainAgeX					140
#define mainAgeY                    466
#define mainStatusX					20
#define mainStatusY                 466  
#define mainPriceX					31
#define mainPriceY					369

#define mainCashLabelX				20
#define mainCashLabelY				545
#define mainCashFieldX				75
#define mainCashFieldY				545

#define seedNavMainX				7
#define seedNavMainY				48
#define seedNavMainWidth			35
#define seedNavMainHeight			35

#define shopNavMainX				7
#define shopNavMainY				48
#define shopNavMainWidth			35
#define shopNavMainHeight			35

#define bottomDragBorder			580 

#define maxNumFlowers				10
#define maxNumSeeds					5
#define maxNumPlantRows				3
#define maxNumPlantsPerRow			5
#define maxNumAnimations			12
#define maxNumItems					18
#define maxNumPlantBreeds			23
#define maxNumFlowerBreeds			26
#define maxNumMagicPlants			6

#define maxNumTutorialTips					50  //tutorial tips - replaced with maxNumPlayerAlerts
#define maxPlayerAlertsInQueue		50
#define firstTipRsc					1400

#define numSecondsBetweenComments	15

#define maxNumSeedsInTray			9
#define maxSeedsInSeedTrayRow		4
#define maxNumSeedRows				12
#define maxNumSeedColumns			10
#define maxNumTools					8

#define seedBoxTopLeftX				242
#define seedBoxTopLeftY				46
#define seedBoxSlotWidth			53
#define seedBoxSlotHeight			34

#define maxNumFertDoses				10

#define maxNumCollGrids				50

#define plantSelectionWidth         92
#define plantSelectionHeight        144

#define plantAreaLeft				270
#define plantAreaTop				43
#define plantAreaRight				(plantAreaLeft + (5 * plantSelectionWidth))
#define plantAreaBottom				(plantAreaTop + 3 * plantSelectionHeight)

#define plantX						323 // 0
#define plantY						117 // 86 // was 33
#define widthOfPlant				30 // was 20
#define heightOfPlant				48 // was 32
#define potBaseX					285 //was 314 // 6  // was 4
#define potBaseY					60 //was 75 //was 100 // 115 // was 51
#define plantIncX					93  // 29 // was 19
#define plantIncY					144 // 48 // was 32

#define fountainX					96  //was 65
#define fountainY					95  //was 37

#define magicPlant1X				75  //was 50
#define magicPlant1Y				123 //was 55
#define magicPlant2X				116 //was 77
#define magicPlant2Y				123 //was 55
#define magicPlant3X				92  //was 63
#define magicPlant3Y				94  //was 37
#define magicPlant4X				135 //was 90
#define magicPlant4Y				96  //was 37

#define magicPlantLifeBase			14
#define magicPlantLifeFlower		16
#define magicPlantIsolaBase			11
#define magicPlantIsolaFlower		10
#define magicPlantKnowledgeBase		4
#define magicPlantKnowledgeFlower	4
#define magicPlantFragrancesBase	13
#define magicPlantFragrancesFlower	13
#define magicPlantWealthBase		2
#define magicPlantWealthFlower		14
#define magicPlantJoyBase			7
#define magicPlantJoyFlower			7


#define seedBoxX					0 // was 4 - ppc  //these defines are calibrated for drawing bitmaps in these locations. For detecting pen events, they are offset -3 when used in the code
#define seedBoxY					86// was 36 - ppc

#define seedTrayX					21 // 143 // for ppc was 100
#define seedTrayY					30 // 64  // for ppc was 20

#define widthOfSeedBox				43 // 24  //changed for ppc
#define heightOfSeedBox				34 // 24  //changed for ppc

#define seedBoxXSeedPos				7 
#define seedBoxYSeedPos				94
//#define seedTrayXSeedPos			23
//#define seedTrayYSeedPos			30

#define shopBoxX					6  // was 4
#define shopBoxY					94 // was 36
#define maxNumShopColumns			6
#define maxNumShopRows				3
#define widthOfShopBox				24 //was 16
#define heightOfShopBox				24 //was 16
#define shopToolAreaX				0
#define shopToolAreaY				80
#define widthOfShopToolArea			143
#define heightOfShopToolArea		81

#define agesUntilSprout				1
#define agesUntilTeen				7
#define agesUntilAdult				18
#define agesUntilBuds				21
#define agesUntilMature				24
#define agesUntilMortal				1720
#define agesUntilBranchKill         7

#define agesUntilSeedsReady			2

#define buyButtonX					194//was 129
#define buyButtonY					231// was 127
#define widthOfBuyButton			42 // was 28
#define heightOfBuyButton			24 // was 16
			
//Drivers License
#define harvestButtonX				47
#define harvestButtonY				293 
#define widthOfHarvestButton		47  
#define heightOfHarvestButton		37  
#define pollinButtonX				140
#define pollinButtonY				294 
#define priceButtonX				218 
#define priceButtonY				235 

//#define ageTextX					21 // was 121
//#define ageTextY					476 // was 81
//#define widthOfAgeDisplay			60  // implemented for ppc
//#define heightOfAgeDisplay			20  // implemented for ppc
//#define maxAgeChars					5
//#define statusTextX					160 // was 101
//#define statusTextY					478 // was 91
//#define widthOfStatusDisplay		90  // implemented for ppc
//#define heightOfStatusDisplay		20  // implemented for ppc

#define maxStatusChars				12
#define seedsTextX					195 // was 130
#define seedsTextY					199 // was 106
#define seedsTextAreaWidth			17  // implemented for ppc
#define seedsTextAreaHeight			20  // implemented for ppc
#define maxSeedsChars				4
#define priceTextX					161 // was 107
#define priceTextY					239 // was 133
#define priceTextAreaWidth			50  // implemented for ppc
#define priceTextAreaHeight			20  // implemented for ppc
#define maxPriceChars				8

#define licensePotX					185 // was 123
#define licensePotY					120 // was 53
#define licensePlantX				101 //179 // was 119
#define licensePlantY				354  // was 34
#define licenseX					98  // 173 // was 115
#define licenseY					335 // 91  // was 34
#define widthOfLicense				41  // was 27
#define heightOfLicense				48  // was 32

#define licenseAreaX				145
#define licenseAreaY				90
#define widthOfLicenseArea			90
#define heightOfLicenseArea			164

#define shopLicenseX				1
#define shopLicenseY				161// was 81
#define widthOfShopLicense1			236// was 157
#define heightOfShopLicense1		90// was from walter 133//was 45 probably don't need shopLicence2 , changed to 62 then converted to current val- w
#define widthOfShopLicense2			127
#define heightOfShopLicense2		62
#define shopText1X					6//was 4
#define shopText1Y					167//was 85
#define shopText2X					6 //was 4
#define shopText2Y					190//was100
#define shopText3X					6//was 4
#define shopText3Y					212 //was 115
#define shopText4X					6 //was 4
#define shopText4Y					235 //was 130

// plant pricing dialog button defines
#define maxPlantPriceDigits			4
#define maxCurrentPriceTextLength	20
#define spinUpButtonX				116
#define spinUpButtonY				30
#define spinDownButtonX				116
#define spinDownButtonY				44
#define spinButtonWidth				14			
#define spinButtonHeight			14
#define plantPricingKeypadButton1X	35
#define plantPricingKeypadButton1Y	70

//- registration dialog keypad defines
#define keypadButton1X				71
#define keypadButton1Y				158
#define keypadButtonWidth			25
#define keypadButtonHeight			23

//seed license
#define parent1X					45 
#define parent1Y					400
#define parent2X					152
#define parent2Y					400
#define seedX						83 
#define seedY						494

#define plantButtonX				5
#define plantButtonY				5

#define mainAnimationAreaX			0
#define mainAnimationAreaY			88 // was 32
#define widthOfMainAnimationArea	144
#define heightOfMainAnimationArea	168

#define trashcanX					156// for ppc - was 122
#define trashcanY					525// for ppc - was 67
//#define seedTrashcanX				111// for ppc - was 74
//#define seedTrashcanY				57 // for ppc - was 11
#define widthOfTrashcan				56 // for ppc  - was 14
#define heightOfTrashcan			75 // for ppc - was  13
		
#define waterMeterX					13  // 154//was 104
#define waterMeterY                 292 
#define healthMeterX				200 //223//was 149 -w
#define healthMeterY                292 // 96//was 38 -w

#define widthOfTool					45 // was 14
#define heightOfTool				45 // was 14
#define widthOfChemical				20 // was 14
#define heightOfChemical			40 // was 14

#define tool1X						18 // 146// was 97
#define tool1Y						136 // 41 // was 1

#define toolXOffset					45 // 24 // was 16

#define maxTextLength				30

#define maxNumSprites				150
#define redrawInterval				4
#define slowRedrawInterval			20
#define widthOfSprite				19
#define heightOfSprite				19
#define bitmapTypeCount				1
#define minSpriteVel				10
#define maxSpriteVel				175
#define spriteAnimRate				4 //num of iterations to keep a anim cell on sprite

#define widthOfNavButton			24
#define heightOfNavButton			24

#define navButton1X					4
#define navButton1Y					4
#define navButton2X					36
#define navButton2Y					4
#define navButton3X					68
#define navButton3Y					4

//SPRITE bitmap defs

#define bitmapFamilyOffset			8

//  ARTHUR defines

#define maxNumAlertsDef				40

#define SecondsPerHour				1800//1800  //this is set to real-time 1/2 hours now
#define HoursPerDay					16//12 //this is set to 12 "game hours" per displayed pet age. with 1/2 hours that's 6 hours per day.
#define HoursUntilAdult				144//72
#define HoursUntilElderly			816//336
#define HoursUntilMortal			1152//336
#define MaxHoursOldAge				336//240 //each hour there is a 1 in MaxHoursOldAge - (years of old age) chance of dying, after mortality

#define StateUpdateInverval			10 //in seconds

#define peepWestBoundryDef			2
#define peepEastBoundryDef			220
#define peepNorthBoundryDef			50
#define peepSouthBoundryDef			220


#define maxNumHeadstones			5

#define petTargOffset				10

#define maxNameSize					13

#define widthOfOffScreenWin			160
#define heightOfOffScreenWin		145
					
#define logoPosX			54
#define logoPosY			46
#define welcomeTextX		52
#define welcomeTextY		95

#define stopped				40	  //this delay is when object are stopped.
#define minFriction			3		
#define velMult				7     //the multiplier of velocity.  Player dragged pixels * velMult = ball velocity

#define westBoundry			7
#define northBoundry		20
#define southBoundry		128
#define eastBoundry			145

#define maxScoreDigits 		8

#define nagFreq				12 //every x hands

// Score gauge position
#define scoreX					130
#define scoreY					2

#define maxScoreDisplayed 	100000

// Level Names
#define levelNameFont			largeFont
#define levelNameLengthMax		16

#define defaultPeriodLength	4
#define minPeriodLength	1

// High Scores settings
#define highScoreFont				stdFont
#define firstHighScoreY				28
#define highScoreHeight				12
#define highScoreNameColumnX		17
#define highScoreScoreColumnX		119		// Right aligned
#define highScoreLevelColumnX		149		// Right aligned
#define nameLengthMax				96
#define highScoreMax		9

// Preferences UI settings
#define startLevelsSelectable			3	
#define defaultStartLevelItem			0

// Owner name retrieval
#define ownerNameBufferLength			100

// registration code specific defines
#define maxRegCodeDigits				8

// tips defines
#define maxTipsTextLength				10000
#define maxNumAlertMessages				23

//- sound related defines
//
#define maxLengthSoundWavName			100

//- vendor/distributor defines
//			NOTE: current distributor for a build is set at top in the LDW COMPILE VERSION FLAG/DEFINES area
//
//			Current URLs
//				www.LDW.com
//				www.handango.com
//				www.astraware.com
//				www.palmgear.com
//
#define maxLengthDistributorURL			100

#define numSeedInventoryRows			3
#define numSeedInventoryColumns			3

#define numUpgradeInventoryRows			3
#define numUpgradeInventoryColumns		5

#define numChemsInventoryRows			3
#define numChemsInventoryColumns		3

#define numNurseryInventoryRows			3
#define numNurseryInventoryColumns		5

#define commonSeedPrice                 50
#define rareSeedPrice					200
#define extinctSeedPrice                2000

//************

/***********************************************************************
 *
 *	Internal Structures
 *
 ***********************************************************************/

//enums
typedef enum
{
	eSeed1 = 0,
	eSeed2,
	eSeed3,
	eSeed4,
	eSeed5,
	eSeed6,
	eSeed7,
	eSeed8,
	eSeed9,
	eSeedLast,
	eSoil1,
	eSoil2,
	eSoil3,
	eWater1,
	eWater2,
	eWater3,
	eScissor1,
	eScissor2,
	eScissor3,
	eNet1,
	eNet2,
	eNet3,
	eSeedbox1,
	eSeedbox2,
	eSeedbox3,
	eUpgradeLast,
	ePoison,
	eChem1,
	eChem2,
	eChem3,
	eChem4,
	eChem5,
	eChem6,
	eChem7,
	eChem8,
	eChem9,
	eChemLast,
	eOrnament1,
	eOrnament2,
	eOrnament3,
	eOrnament4,
	eOrnament5,
	eOrnament6,
	eOrnament7,
	eOrnament8,
	eOrnament9,
	eOrnament10,
	eOrnament11,
	eOrnament12,
	eOrnament13,
	eOrnament14,
	eOrnament15,
	eOrnamentLast,
	eFountain1,
	eFountain2,
	eFountain3,
	eGeneMorph

}ItemChoiceEnum;

typedef enum
	{
	plantOfLife = 0,
	plantOfKnowledge,
	plantOfJoy,
	plantOfWealth,
	plantOfIsola,
	plantOfFragrances
	} MagicPlantEnum;
	
typedef enum
	{
	main,
	shop,
	seed,
	garden,
	dialog,
	intro,
	intro2,
	options,
	about
    } GameFormType;	
	
typedef enum
	{
	nothing,
	bees,
	glowing
	
	} PlantAnimationType;


typedef enum
	{
	statRealGameHoursThisGame,	
	statSeedsPlanted,			
	statPlantsSold,				
	statMoneyEarned,				
	statAvgPricePerPlant,		
	statNewBreedsFound,			
	statMagicPlantsFound		
	} GameStatType;


typedef struct
	{
	ldwPoint topLeft;
	ldwPoint extent;

	} RectangleType;

typedef struct
	{
	int numFrames;
	int startBM;
	int currentFrame;
	ldwPoint pos;
	} AnimationType;	

//SPRITE

typedef struct
{
	int price;
	bool playerHas;
	ItemChoiceEnum itemID; //this should be an item type enum
	StringId fullDesc;
	StringId shortDesc;
	int charges;
	int longDescSizeAdjust;
	int priceTextAdjust;
} InventoryType;

typedef struct
	{
	bool exists;
	int xPos;
	int yPos;
	int xVel;
	int yVel;
	int xMom;
	int yMom;
	int baseBM;
	int BMIdx;
	int BMIdxCounter;
	int BMFamily;
	
	ldwRect area;
	
	} SpriteType;
	
typedef struct
{
		
	long gameStartTime;
	long moneyEarned;
	int plantsSold;
	long averagePrice;
	int plantsCured;
	int seedsPlanted;
	int waterPoured;
	int branchesPruned;
	int netSwung;
	int bugsCaptured;
	int visitorsInNursery;
	int magicPlantsDiscovered;

	bool      discoveredBreed[24][24]; 
	
} StatsType;
	
typedef struct
	{
	int baseSkin;
	int flowerSkin;
	} SkinType;

typedef struct
	{	
	int cost;
	bool have;
	} ItemType;
		
typedef struct
	{
	SkinType parentSkin1;
	SkinType parentSkin2;
	
	int baseType;
	int flowerType;
	bool exists;

	int seedBmp;
	int price;
	
	} SeedType;
	
enum 
{
	eMaxPlantSections = 60,
	eMaxPlantBranches = 10,
	eMaxFlowers       = 6	
};

typedef enum
{
	eEmptySection,
	eGrowing,
	ePruned,
	eUserPruned,
	eGrowingDead,
	eUserPrunedDead
}
PlantSectionStatus;

typedef struct
{
	int   branchIndex;
	int   sectionIndex;
	float maxScale;

	PlantSectionStatus status;
}
PlantBranchType;

typedef struct
{
	int   flowerPointIndex;
	int   orientation;
	float maxScale;

	int   curX;				// current attachment point
	int   curY;
	float curScale;			// current scaling

	PlantSectionStatus status;
}
PlantFlowerType;

typedef struct
{
	int                plantPartId;
	PlantSectionStatus status;
	float              ageUntilBirth;
	int                zOrder;

	int   curX;			// current screen postion (base point)
	int   curY;
	float curScale;		// current scaling


	int branchCount;
	PlantBranchType branch[eMaxPlantBranches];
	int flowerCount;
	PlantFlowerType flower[eMaxFlowers];
}
PlantSectionType;

typedef struct
{
	char name[nameLengthMax];
}
PlantNameType;

typedef struct
	{
	ldwUINT32 birthday;
	ldwUINT32 lastTimeChecked;
	ldwUINT32 secondsAccumilated;

	float agesChecked;
	float age;

	float growthSpurtAge;

	int potIndex;	
	int soil;
	int water;
	int health;
	int infested;
	
	int waterUsage;
	int maxAge;
	int resistance;
	
	bool exists;

	int animation;
	int animationCell;
	
	int price;
	int value;

	SkinType skin;
	SeedType seed;
	int originatingSeedBmp;

	int fertilityBoost;

	int plantMaxGrowth;
	int timesFertilized;
	int targetFlowerCount;
	int flowerMaxGrowth;
		
	int seedsAvailable;
	int seedsTaken;
	int agePollinated;
	
	bool branchKillAttempted;
	bool forSale;
	bool sold;

	int snapShotX;
	int snapShotY;

//   new data structure for branching plants

	PlantSectionType sections[eMaxPlantSections];

	int fadeSeedSkin;
	float seedSkinAlpha;
}
PlantType;
//

#define maxChemicalTraySlots 4

typedef struct
{
	bool				m_bIsUsedSlot;
	ItemChoiceEnum		m_eChemicalID;
	int					m_iUsesRemaining;
}
ChemicalTraySlot;

#define MAX_PLAYER_NAME_LENGTH 32

typedef enum
{
	eNULLScene,
	eMainScene,
	eMenuScene,
	eSplashScene,
	eGamewinScene,
	eCollectingScene,
	eIntro1Scene,
	eIntro2Scene,
	eLoadingScene,													   
	eHelpScene,
	eSeedScene,
	eSellScene,
	eShopScene
   ,eSnapShotScene
}
GameSceneEnum;	

struct PopupMessageRequestType
{
	StringId whatMessage;
	GameSceneEnum whatScene;
};

typedef enum
{
	eOrangeCanvas,
	eGreenCanvas
}
DialogColorEnum;

//STUFF THAT IS SAVED IN THE SAVEFILE

struct theGameData
{
	enum {eMaxTextLength = 40};

	char playerName[MAX_PLAYER_NAME_LENGTH + 1];
	ldwUINT32 scoreID;

	StatsType stats;
	StatsType globalStats;

	int   difficulty;
	float musicVol;

	int   playTrack1;
	int   playTrack2;
	int   playTrack3;
	int   playTrack4;

	float soundVol;

	int minutesPerAge;

	int  textLength;
	char textBuffer[eMaxTextLength + 1];

	bool hasShutDown;
	bool gameInProgress;

	bool isDead;
	bool isSick;
	bool haltSprites;
	bool sounds;
	bool waitIntro;
	
	int inHand;
	
	//tools
	int toolUpgrade[maxNumTools + 1];
	int fountain; 
	int numFertDoses;
	
	ldwUINT32 currentTime;
	ldwUINT32 shopSeedTimer;

	SeedType inventorySeeds[numSeedInventoryRows][numSeedInventoryColumns];
	InventoryType upgradeInventory[numUpgradeInventoryRows][numUpgradeInventoryColumns];
	InventoryType chemsInventory[numChemsInventoryRows][numChemsInventoryColumns];
	InventoryType nurseryInventory[numNurseryInventoryRows][numNurseryInventoryColumns];

	int plantValues[maxPlantSpecies + 3][maxPlantSpecies + 3];
	int plantPrices[maxPlantSpecies + 3][maxPlantSpecies + 3];

	ItemType item[maxNumItems];
	
	//SPRITE -- Plant Tycoon
	GameFormType currentForm;
	long money;
	
	//magic plant flags
	bool magicPlant[6];
		
	PlantType plant[maxNumPlantRows][maxNumPlantsPerRow];
	SeedType seedTray[maxNumSeedsInTray];
	SeedType seedBox[maxNumSeedRows][maxNumSeedColumns];
	
	PlayerAlertType playerAlert[maxPlayerAlertsInQueue + 1];

	bool tutorialTip[eTTipTerminator + 1];

	bool collectableState[maxNumCollectableTypes + 1];

	ldwUINT16 regKey;
	ChemicalTraySlot chemicalTray[maxChemicalTraySlots];

	StringId mLastTipInstruction;

};


enum GameSaveSlotEnum
{
	GameSaveSlotNULL,
	GameSaveSlot1,
	GameSaveSlot2,
	GameSaveSlot3,
	GameSaveSlot4,
	GameSaveSlot5
};

struct theGameInfo 
{
	GameSaveSlotEnum currentSaveSlot;
	GameSaveSlotEnum priorSaveSlot;

	bool registered;
	bool fullscreen;

	char player1Name[MAX_PLAYER_NAME_LENGTH + 1];
	char player2Name[MAX_PLAYER_NAME_LENGTH + 1];
	char player3Name[MAX_PLAYER_NAME_LENGTH + 1];
	char player4Name[MAX_PLAYER_NAME_LENGTH + 1];
	char player5Name[MAX_PLAYER_NAME_LENGTH + 1];

	bool player1SaveSlotActive;
	bool player2SaveSlotActive;
	bool player3SaveSlotActive;
	bool player4SaveSlotActive;
	bool player5SaveSlotActive;

	bool saveGameFileLoadError; //- true when loading save game file has errors (i.e. missing file, etc) 

	ldwUINT32 firstStartTime;
	ldwUINT32 firstRegTime;
};

class theGameState : public theGameData, public theGameInfo, public ldwGameState
{
public:

	enum
	{
		eGameInfoSlot     = 0,
		ePlayer1GameSlot,
		ePlayer2GameSlot,
		ePlayer3GameSlot,
		ePlayer4GameSlot,
		ePlayer5GameSlot,
		eRegGameSlot     = 11
    };

	static theGameState * Create();	
	static theGameState * Get();

	static void Destroy();

	~theGameState();

	const char* GetGameTitle();
	const char*	GetGameName();

	GameSceneEnum currentGameScene;
	void SetCurrentGameScene(GameSceneEnum whichScene) { currentGameScene = whichScene; };	
	int  GetCurrentGameScene() {return currentGameScene;}
	int GetGameWindowWidth();
	int GetGameWindowHeight();
	int GetBitsPerPixel();

	void InitPlantValues();
	void InitPlantStartingPrices();
	void SpawnInventorySeeds();

	int CheckSoilUpgradeLevel();
	int CheckWaterUpgradeLevel();
	int CheckSeedboxUpgradeLevel();
	int CheckScissorUpgradeLevel();
	int CheckNetUpgradeLevel();

	void SetTutorialTipsOn();
	void SetTutorialTipsOff();

	void InitInventory();

	bool StartWindowed();

	void Load();

	bool Load(int slot);
	bool Save(int slot);

	bool SaveCurrentGame();
	bool LoadCurrentGame();

	void AutoSaveGame();

	void RemoveGameFile(int slot);

	bool GameHasExpired();

	long GetStatRealGameHoursThisGame();

	void Init();
	void RestartCurrentGame();

#ifdef _MAC
	bool ChangeToWindowedPending; 
#endif
	void InitGameInfo();
	void InitSpeciesNames();

	void InitSeed (SeedType * aSeed);

	void  DailyCheck();
	//int   GamePlayerAlertEnqueue (PlayerAlertType whichAlert);
	//void  GamePlayerAlertInit();
	//int   GameAlertDisplay();
	bool     TipIsShowing()                         {return mTipShowing;}
	
	bool DisplayTip(StringId whichTip, ldwScene *whichScene);
	bool TipIsTutorialInstruction(StringId tip) {return tip > eTTipBeginNewTTips && tip < eTTipInfo26 && (tip & 1) == (eTTipInstruct1 & 1);}
	StringId GetLastTipInstruction()                {return (tutorialTip[eTTipInfo32] || tutorialTip[eTTipInfo30]) ? mLastTipInstruction : eNoString;}

	int RegisterNewMagicPlant(int baseType, int flowerType);
	bool CheckIsMagicPlant(int baseType, int flowerType);

	bool PutPopupInQueue(StringId whichMessage, GameSceneEnum whatScene);

	//PlayerAlertType GamePlayerAlertDequeue();
	//PlayerAlertType GamePlayerAlertPeekTop ();
	//PlayerAlertType GamePlayerAlertDisplay(ldwScene *currentScene);

	PopupMessageRequestType popupMessageQueue[maxNumWaitingPopups];

	PlantNameType plantName[maxNumPlantBreeds + 3][maxNumPlantBreeds + 3];
	
	ldwUINT32 CHECKTIMER;
	ldwUINT32 DEALERSAYTIMER;
	ldwUINT32 REDRAWTIMER;

	int		  FOCUS;

	void SpawnSeeds();
	void SpawnStartingPlants();
	void SpawnStartingChems();
	

protected:

	void InitOptions();
	void InitPlants();
	void InitAllSeeds();

	bool mTipShowing;

	theGameState();
	
	ldwUINT32 mAutoSaveTimer;
};

#endif
