//
//		Definition of the main game class
//
#ifndef THE_GAMEWIN_SCENE_H
#define THE_GAMEWIN_SCENE_H


#include "ldwScene.h"
#include "ldwImage.h"

class theGameState;
class theStringManager;
class theSoundManager;

class ldwButton;
class ldwTextControl;
class ldwGameWindow;
class theGraphicsManager;

class theGamewinScene : public ldwScene
{
public:
	
	theGamewinScene();
	~theGamewinScene();

	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);

protected:

	void DrawScene();
	void UpdateScene();

private:

	ldwGameWindow    *gameWindow;
	theGameState     *gs;
	theStringManager *stringMgr;
	theSoundManager  *soundMgr;
	theGraphicsManager *gm;

	ldwUINT32 timer;
	bool      visitedAtLeastOnce;

	int  fadeInCount;
	bool beginFadeOut;
	int  fadeOutCount;
	bool fadeInComplete;
	bool fadeOutComplete;

	float fadeTrans;

	ldwTextControl *line1;
	ldwTextControl *line2;
	ldwTextControl *line3;
	ldwTextControl *line4;
	ldwTextControl *line5;

	//ldwImageGrid *BG;

	ldwRect fadeInOutRect;
};
#endif