//
//	Class definition for Test Dialog class
//

#ifndef THE_OPTIONS_DIALOG_H
#define THE_OPTIONS_DIALOG_H

#include "theSoundFxManager.h"
#include "ldwTiledDialog.h"
#include "ldwImage.h"
#include "ldwGameWindow.h"
#include "theFloatingAnims.h"
#include "theGameState.h"
#include "theStringManager.h"

class ldwButton;
class ldwImageGrid;
class theGraphicsManager;

typedef struct  
{
	bool soundOn;
	bool fullscreen;
	int difficulty;
	int gameSpeed;
	float soundVol;
	float musicVol;
}OptionsDataStruct;

typedef enum
{
	eOptGreenCanvas,
	eOptRedCanvas,
	eOptOrangeCanvas,
	eOptNoColor
} OptDialogColorEnum;	

class theOptionsDialog : public ldwTiledDialog
{
public:

	theOptionsDialog(char *labelA,  DialogColorEnum dialogCanvas);
	~theOptionsDialog();
	
	int  GetResult();

	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);

private:

	ldwRect bounds;

	int popupSize;

	bool showFullscreenOption;

	bool slider1InHand;
	bool slider2InHand;
	int slider1X;
	int slider2X;

	const int cChoiceAButtonID;

	theFloatingAnims *floatingAnim;
	theSoundManager *soundMgr;
	theGameState * gs;

	int correctedLeft;
	int centerX;
	int correctedTop;

	ldwImageStrip * checkBox;
	ldwImage * checkBoxChecked;
	ldwImage * radioBtnOff;
	ldwImage * radioBtnOn;
	ldwImage * sliderFrame;
	ldwImage * sliderHandle;

	ldwGameWindow *gameWindow;
	ldwSoundTrack  *soundTrack;
	ldwSoundFx     *soundFx;
	theStringManager *strMgr;
	theGraphicsManager *gm;

	OptionsDataStruct optionsData;

protected:

	bool paramaterUsed ;

	void DrawNoFadeScene();

	ldwImageGrid   *mTiles;
	ldwButton      *choiceAButton;

	int  mResult;
};

#endif
