//
//		Definition of the plant manager class
//
#ifndef THE_PLANT_MANAGER_CLASS_H

#define THE_PLANT_MANAGER_CLASS_H

#include "ldwTypes.h"
#include "theGameState.h"

enum 
{
	eNoPlantClass,

	eIvyClass,eCaladiumPlantClass,eLemonGrassClass,eOrchidClass,eFlower1Class,	    // 1 - 5

	eBananaPlantClass,eFernClass,eAnanasClass,eDieffenbachiaClass,eBananaTreeClass,	  	// 6 - 10

	eLemonTreeClass,eBambooTreeClass,eBonsaiTreeClass,eOakTreeClass,eCowboyCactusClass,  	// 11 - 15

	ePearCactusClass,eBallCactusClass,eBopPlantClass,eTigerFernClass,ePitcherPlantClass,  // 16 - 20

	eWillowTreeClass,eRoseClass,eRidgedCactusClass,									// 21 - 23

	ePlantClassCount
};

class thePlantClass;
class theGraphicsManager;

class thePlantManager
{
public:

	static thePlantManager *Get();
	static void Destroy();

	void ClearPlants();
	void SyncPlants();

	void PlantSeed(SeedType *seed,int targetRow,int targetColumn);

	void DeletePlant(int whichPlant);
	void DeletePlant(int whichRow,int whichColumn);

    thePlantClass *GetPlant(int whichPlant);
	thePlantClass *GetPlant(int whichRow,int whichColumn);
	thePlantClass *GetPlant(SkinType *skin);

	void DrawPlants(bool allowPruning, int exceptForRow, int exceptForColumn);

	void DrawPlantForNursery(int whichPlant,int x,int y);
	void DrawPlantForNursery(int whichRow,int whichColumn,int x,int y);

	void DrawMagicPlantForNursery(int baseType,int flowerType,int x,int y);

	void DrawPlant(int whichPlant,int x,int y,bool enablePruning = true);
	void DrawPlant(int whichRow,int whichColumn,int x,int y,bool enablePruning = true);

	ldwPoint GetFlowerPoint(int whichPlant);

	void AgePlants(ldwUINT32 currentTime);
	bool PlantIsForSale (int row, int column);

	void AddFlowers (PlantType * whichPlant, int numFlowers);

	void SwapPlants(int row1, int column1, int row2, int column2);

	void MutatePlant(int row,int column);
	void StartGrowthSpurt(int row,int column);

protected:

	static thePlantManager *mInstance;

	thePlantManager();
	~thePlantManager();

	void            BuildPlantClass(int whichRow,int whichCol,PlantType *whichPlant);
	thePlantClass * BuildPlantClass(PlantType *whichPlant);

	void ClearThePlants();

	void SetPlantValue(PlantType *whichPlant);

	theGameState       *gs;
	theGraphicsManager *gm;

	thePlantClass *thePlants[maxNumPlantRows][maxNumPlantsPerRow];

	PlantType      basePlantTypes[ePlantClassCount];
	thePlantClass *allPlants[ePlantClassCount];
};
#endif