//
//		Definition of the String Manager class
//
//
#ifndef THE_STRING_MANAGER_H
#define THE_STRING_MANAGER_H

#include "ldwFont.h"

#define numRandomTips 50

enum StringId
{
	eNoString = -1,

	eNULLString = 0,

	eTIME_STOPPED,

	eSayInternalError,

	ePlayer,
	ePleaseEnterANickName,
	eChangePlayer,
	eNewPlayer,
	
	ePlay,
	eStartOver, 
	eOptions,   
	eHelp,      
	eQuit,      
	eMenu,

	eVersionLimited,
	eVersion,		
	
	eYes,
	eNo,	

	eOK,
	eCancel,
	eDelete,
	eRefresh,
	eDeletePlayerConfirm,

	eAttemptingConnect,
	eStatsUpdated,	   
	eUpdateFailed,	   
	eNoStats,		   

	eYourStatistics,	
	eInternetStatistics,
	eRealHoursPlayed,	
	eYourRank,			
	ePressRefresh,		
	eAverage,			

	eMoneyEarned,	
	ePlantsSold,		
	eAveragePrice,	
	ePlantsCured,		
	eSeedsPlanted,
	eWaterPoured,
	eBranchesPruned,
	eNetSwung,
	eBugsCaptured,
	eVisitorsInNursery,
	eMagicPlantFound,
	eSpeciesFound,

	eSounds,
	eMusic,
	eMusicTracks,
	eEnabled,
	eDisabled,

	eDifficulty,
	eEasy,
	eMedium,
	eHard,

	eGameSpeed,
	eStopTime,
	eNormal,
	eHalfSpeed,
	e2xSpeed,

	eFullscreen,
	eOn,
	eOff,

	eSayConfirmRestart,

	eYourCash,
	eAge,
	ePrice,
	eShopRandomSeed,
	eShopCommonSoil,
	eShopNormalWater,
	eShopNormalPlantFood,
	eShopInsectPoison,
	eShopFountain,
	eShopBioOrganicSoil,
	eShopRandomExoticSeed,
	eShopPureSpringWater,
	eShopHighQualityPlantFood,
	eShopInstaGrow,
	eShopLargeFountain,
	eShopRareSeed,
	eShopIsolaSoil,
	eShopGelCompound,
	eShopRadioactivePlantFood,
	eShopMutationLiquid,
	eShopElaborateFountain,
	ePleaseRegister,
	eYouAlreadyHaveIt,
	eCollectionsOf,
	
	eDead,
	eInfested,
	eUnhealthy,
	eHealthy,
	ePollinated,
	eDepleted,
	eTooYoung,
	eMature,
	eNA,

	eSayCommonButterflies,
	eSayUncommonButterflies,
	eSayRareButterflies,
	eSayCommonShells,
	eSayUncommonShells,
	eSayRareShells,
	eSayCommonPebbles,
	eSayUncommonPebbles,
	eSayRarePebbles,
	eSayCommonBeetles,
	eSayUncommonBeetles,
	eSayRareBeetles,

	eSayWelcome,			
	eSayNoSoil,
	eSayAlreadyHaveSoil,
	eSayPollinatePlant,	
	eSayPollinated,		
	eSayNotMature,  		
	eSayAlreadyPollinated,
	eSayPlantSelected,	
	eSayNotPollinated,	
	eSaySeedsTaken,		
	eSaySeedsNotRipe,	
	eSaySeedBoxFull,		
	eSaySeedMovedToBox,	
	eSayPotSelected,		
	eSayDontNeed,		
	eSayNeedCash,		
	eSayClickAnywhere,	
	eSayPlantSold,		
	eSayNoPlantFood,		
	eSayNoPlantToPrice,	
	eSayNoRoomOnTray,	
	eSayDeadPlant,		
	eSayTooYoung,		
	eSayNoPlant,			
	eSayNoPlantSoil,		
	eSaySoilToHard,		
	eSayAlreadyPlant,	
	eSayOnlyRegistered,	
	eSayNoSeeds,			
	eSayAlreadySeeds,	
	eSayVisitLDW,		
	eNeedYoungerPlant,
	eCommonInsectSold,
	eUncommonInsectSold,
	eRareInsectSold,
	eInsectCollected,
	eNoPlantThere,

	eReplayTutorialInstruction,

	eIntro1Line1,
	eIntro1Line2,
	eIntro1Line3,
	eIntro1Line4,
	eIntro1Line5,
	eIntro1Line6,

	eIntro2Line1,
	eIntro2Line2,
	eIntro2Line3,
	eIntro2Line4,
	eIntro2Line5,
	eIntro2Line6,

	eGamewinLine1,
	eGamewinLine2,
	eGamewinLine3,
	eGamewinLine4,
	eGamewinLine5,

	eTTipBeginNewTTips,
	eTTipInstruct1,
	eTTipInfo2,
	eTTipInstruct3,
	eTTipInfo4,
	eTTipInstruct5,
	eTTipInfo6,
	eTTipInstruct7,
	eTTipInfo8,
	eTTipInstruct9,
	eTTipInfo10,
	eTTipInstruct11,
	eTTipInfo12,
	eTTipInstruct13,
	eTTipInfo14,
	eTTipInstruct15,
	eTTipInfo16,
	eTTipInstruct17,
	eTTipInfo18,
	eTTipInstruct19,
	eTTipInfo20,
	eTTipInstruct21,
	eTTipInfo22,
	eTTipInstruct23,
	eTTipInfo24,
	eTTipInstruct25,
	eTTipInfo26,
	eTTipInstruct27,
	eTTipInfo28,
	eTTipInstruct29,
	eTTipInfo30,
	eTTipInstruct31,
	eTTipInfo32,

	eTTipStandAloneWelcome,
	eTTipStandAloneFirstDeath,
	eTTipStandAloneFirstPruningDeath,
	eTTipStandAloneFirstSoldPlant,
	eTTipStandAloneCollectedBugs,

	eTTipStandAloneMP1,
	eTTipStandAloneMP2,
	eTTipStandAloneMP3,
	eTTipStandAloneMP4,
	eTTipStandAloneMP5,
	eTTipStandAloneMP6,

	eTTipStandAloneRealTime,
	eTTipStandAloneFinal,
	eTTipStandAloneMaskTips,

	eTTipTerminator,

	eTipInternalUse,

	eTipLastAutoOff,

	eRandomTip1,
	eRandomTip2,
	eRandomTip3,
	eRandomTip4,
	eRandomTip5,
	eRandomTip6,
	eRandomTip7,
	eRandomTip8,
	eRandomTip9,
	eRandomTip10,
	eRandomTip11,
	eRandomTip12,
	eRandomTip13,
	eRandomTip14,
	eRandomTip15,
	eRandomTip16,
	eRandomTip17,
	eRandomTip18,
	eRandomTip19,
	eRandomTip20,
	eRandomTip21,
	eRandomTip22,
	eRandomTip23,
	eRandomTip24,
	eRandomTip25,
	eRandomTip26,
	eRandomTip27,
	eRandomTip28,
	eRandomTip29,
	eRandomTip30,
	eRandomTip31,
	eRandomTip32,
	eRandomTip33,
	eRandomTip34,
	eRandomTip35,
	eRandomTip36,
	eRandomTip37,
	eRandomTip38,
	eRandomTip39,
	eRandomTip40,
	eRandomTip41,
	eRandomTip42,
	eRandomTip43,
	eRandomTip44,
	eRandomTip45,
	eRandomTip46,
	eRandomTip47,
	eRandomTip48,
	eRandomTip49,
	eRandomTip50,
	

	eRegistered,		
	eUnregistered,
	ePleaseBuyAt,	

	eAskDeletePlant,
	eAskDeleteSeed,
	eAskReplaceFood, 
	eAskReplaceSlot4,
	eAskBuyItem,		
	eSetPlantPrice,
	ePlantPriceLabel,
	eForSale,

	ePurchaseTitle,
	ePurchaseDescSoil1,
	eShortDescSoil1,
	ePurchaseDescSoil2,
	eShortDescSoil2,
	ePurchaseDescSoil3,
	eShortDescSoil3,
	eShortDescSeed1,
	ePurchaseDescSeed1,
	eShortDescSeed2,
	ePurchaseDescSeed2,
	eShortDescSeed3,
	ePurchaseDescSeed3,
	ePurchaseDescWater1,
	eShortDescWater1,
	ePurchaseDescWater2,
	eShortDescWater2,
	ePurchaseDescWater3,
	eShortDescWater3,
	ePurchaseDescShears1,
	eShortDescShears1,
	ePurchaseDescShears2,
	eShortDescShears2,
	ePurchaseDescShears3,
	eShortDescShears3,
	ePurchaseDescNet1,
	eShortDescNet1,
	ePurchaseDescNet2,
	eShortDescNet2,
	ePurchaseDescNet3,
	eShortDescNet3,
	ePurchaseDescBox1,
	eShortDescBox1,
	ePurchaseDescBox2,
	eShortDescBox2,
	ePurchaseDescBox3,
	eShortDescBox3,
	eShortDescTurtle,
	ePurchaseDescTurtle,
	eShortDescSundial,
	ePurchaseDescSundial,
	eShortDescWeatherVane,
	ePurchaseDescWeatherVane,
	eShortDescBugZap,
	ePurchaseDescBugZap,
	eShortDescOwl,
	ePurchaseDescOwl,
	eShortDescBuddha,
	ePurchaseDescBuddha,
	eShortDescBirdHouse,
	ePurchaseDescBirdHouse,
	eShortDescCherub,
	ePurchaseDescCherub,
	eShortDescBench,
	ePurchaseDescBench,
	eShortDescFountain,
	ePurchaseDescFountain,
	eShortDescSign,
	ePurchaseDescSign,
	eShortDescFence,
	ePurchaseDescFence,
	eShortDescGate,
	ePurchaseDescGate,
	eShortDescCashReg,
	ePurchaseDescCashReg,
	eShortDescPaint,
	ePurchaseDescPaint,
	eShortDescPlantFood,
	ePurchaseDescPlantFood,
	eShortDescVitamins,
	ePurchaseDescVitamins,
	eShortDescInsecticide,
	ePurchaseDescInsecticide,
	eShortDescBioFood,
	ePurchaseDescBioFood,
	eShortDescRescue,
	ePurchaseDescRescue,
	eShortDescFertility,
	ePurchaseDescFertility,
	eShortDescInstaGrow,
	ePurchaseDescInstaGrow,
	eShortDescMutation,
	ePurchaseDescMutation,
	eShortDescDew,
	ePurchaseDescDew,
	ePurchaseDescFountain1,
	eShortDescFountain1,
	ePurchaseDescFountain2,
	eShortDescFountain2,
	ePurchaseDescOrnament1,
	eShortDescOrnament1,
	ePurchaseDescChems1,
	eShortDescChems1,
	ePurchaseDescTool1,
	eShortDescTool1,
	ePurhcaseDescTool2,
	eShortDescTool2,
	ePurchaseDescTool3,
	eShortDescTool3,
	ePurchasePriceLabel,
	eNoRoomInTrayMsg,
	eBuyButtonTxt,
	eSayNoSpaceInTray,

	eMainSeedsLabel,
	eMainPollenLabel,
	eMainToolsLabel,
	eMainCollectLabel,
	eMainMenuLabel,
	eMainReturnLabel,
	eMainNurseryLabel,
	eMainSuppliesLabel,
	eMainSellUrPlantsLabel,
	eMainEditPriceLabel,
	eMainSellLabel,
	eMainSellAllLabel,
	eMainSellToggleLabel,
	eMainSellingLabel,
	eMainTimePausedLabel,
	eMainTimeUnPausedLabel,
	eMainBudsLabel,
	eMainMatureLabel,
	eMainProducingLabel,
	eMainNoPlantLabel,
	eMainUnknSpediesLabel,
	eMainShowPlantedSeed,
	eMainTrashLabel,

	eUniversalMainLabel,
	eUniversalDoneLabel,
	eUniversalLoadingLabel,
	

	eShopGardeningLabel,
	eShopToolUpgdLabel,
	eShopChemsLabel,
	eShopImportSeedsLabel,
	eSeedsSeedStorageLabel,
	eSeedsSeedBoxUpgdLabel,

	eCollectionMyBugsLabel,
	eCollectionButterfliesLabel,
	eCollectionStatsLabel,

	eHelpHelpLabel,
	eHelpCreditsLabel,
	eAskingPriceLabel,
	eSoldPlantLabel,
	eSoldSeedLabel,

	ePictureTakenMsg,
	eChangePlayerName,

	eChemicalName1,
	eChemicalName2,
	eChemicalName3,
	eChemicalName4,
	eChemicalName5,
	eChemicalName6,
	eChemicalName7,
	eChemicalName8,
	eChemicalName9,
	eRemainingUses,

	eThatIsCommonBug,
	eThatIsUncommonBug,
	eThatIsRareBug,
	eSayNeedPrereq,
	eTakeSnapShot,
	eStringCount
};

typedef enum
{
	eSayNothing,
	welcome			= eSayWelcome,
	clickToBegin	= eNULLString,
	noSoil			= eSayNoSoil,
	alreadySoil		= eSayAlreadyHaveSoil,
	havePollin		= eSayPollinatePlant,
	pollinated		= eSayPollinated,
	notMature		= eSayNotMature,
	alreadyFert		= eSayAlreadyPollinated,
	plantSelected	= eSayPlantSelected,
	notPollinated	= eSayNotPollinated,
	seedsTaken		= eSaySeedsTaken,
	seedsNotRipe	= eSaySeedsNotRipe,
	seedBoxFull		= eSaySeedBoxFull,
	seedMovedToBox	= eSaySeedMovedToBox,
	emptySelected	= eSayPotSelected,
	dontNeed		= eSayDontNeed,
	notEnufCash		= eSayNeedCash,
	clickAnywhere	= eSayClickAnywhere,
	youSold			= eSayPlantSold,
	noMoreFert		= eSayNoPlantFood,
	noPlantPrice	= eSayNoPlantToPrice,
	mustHaveEmpty	= eSayNoRoomOnTray,
	plantDead		= eSayDeadPlant,
	tooYoungToSell	= eSayTooYoung,
	noPlant			= eSayNoPlant,
	noSoilPlant		= eSayNoPlantSoil,
	soilTooHard		= eSaySoilToHard,
	alreadyPlant	= eSayAlreadyPlant,
	onlyRegistered	= eSayOnlyRegistered,
	noSeeds			= eSayNoSeeds,
	alreadySeeds	= eSayAlreadySeeds,
	visitLDW		= eSayVisitLDW
}
SayType; //- 32 different text messages (0 - 31) as of 7/12/2004

typedef enum
{
	black,
	green,
	yellow,
	white,
	red
}
SayColorType;

typedef enum
{
	noCurrentAlert, //- noCurrentAlert designates that there is no current alert in the queue - Used for alert queue handling. 
					//		Do NOT use noCurrentAlert for an actual alert!
					//
	mainHelpInstructions,

	plantLife,
	plantKnowledge,
	plantJoy,
	plantWealth,
	allPlants,
	ttip0,
	ttip1,
	ttip2,
	ttip3,
	ttip4, 
	ttip5,
	ttip6,
	ttip7,
	ttip8,
	ttip9,
	ttip10,
	ttip11,
	ttip12,
	ttip21,
	ttip31,
	ttip41,

	specialGameWinConditionAlert,

	//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	//- WARNING: Enter any new PlayerAlertTypes ABOVE this line! ^
	//															 
	//		NOTE: make sure maxNumTutorialTips is ALWAYS larger than the number of alerts here, maxNumTutorialTips used for
	//					initialization of the tutorial tips array, etc. 
	//
	lastAlert_EndOfAlertType	//- lastAlert_EndOfAlertType 
								//							(0) VORSICHT: the following is not approved for use, use maxNumTutorialTips
								//											until further notice - 7/26/2004 RPS
								//							(1) can be used to designate end of PlayerAlertType
								//							(2) holds the total number of PlayerAlerts - 1
								//							(3)	(lastAlert_EndOfAlertType + 1) == (total # of player alerts)
								//								
}
PlayerAlertType;


class theStringManagerImpl;

class theStringManager
{
public:

	static theStringManager *Get();
	static void Destroy();

	ldwFont *clearFont;

	enum
	{
		eEnglish,
		eGerman,

		eLanguageCount
	};

	void LoadFonts();

	char *GetString(StringId stringId);

	void SetLanguage(int language);
	int  GetLanguage();

	void DealerSay(SayType sayWhat,SayColorType sayColor);

	void ShowMoney(long money);
	void ShowMoney (long money,int x,int y);

	void DrawNumber(int num,int x,int y,bool scale = false);
	void DrawNumberWhite(int num,int x,int y);

	void DrawMoney(int num,int x,int y,bool scale = false);
	void DrawMoneyWhite(int num,int x,int y);

	void DrawString(StringId stringId,int x, int y,bool scale = false);
	void DrawString(StringId stringId,int x, int y,bool scale, ldwColor whatColor);

protected:
	
	static theStringManager *mInstance;

	theStringManager();
	~theStringManager();

	theStringManagerImpl *mStringManager;
};
#endif